SystemOrganization addCategory: #'Seaside-Tests-Pharo-Development'!

TestCase subclass: #WAPackagingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Development'!

!WAPackagingTest methodsFor: 'tests' stamp: 'dkh 1/27/2010 16:28'!
testPackagingValidity
	"if this test fails, it is because the current version of the Metacello configuration for Seaside3.0 doesn't match the current GRPackage specifications"

	Smalltalk
		at: #ConfigurationOfSeaside30
		ifPresent:
			[ :cl | 
			| gr me exceptions grease |
			gr := Dictionary new.
			GRPackage packages do: [ :pkg | gr at: pkg name put: pkg ].
			me := Dictionary new.
			cl project currentVersion packages do: [ :pkg | me at: pkg name put: pkg ].	"the following only apply when the system if fully loaded"
			false
				ifTrue:
					[ exceptions := #('Sport-2' 'DynamicBindings' 'Swazoo-2' 'KomHttpServer' 'KomServices').
					me keys do: [ :key | gr at: key ifAbsent: [ self assert: (exceptions includes: key) ] ].
					exceptions := #('Grease-Core' 'Grease-Tests-Core' 'Grease-Pharo-Core' 'Grease-Tests-Pharo-Core').
					gr keys do: [ :key | me at: key ifAbsent: [ self assert: (exceptions includes: key) ] ] ].
			exceptions := #('Seaside-FileSystem' 'Seaside-Swazoo' 'Seaside-Adaptors-Comanche' 'Seaside-Tools-OmniBrowser' 'Seaside-Tests-Slime').
			grease := #('Seaside-Tests-Core' 'Seaside-Tests-Pharo-Continuation' 'Seaside-Core' 'Seaside-Pharo-Core' 'Seaside-Pharo-Flow' 'Seaside-Pharo-Continuation' 'Seaside-Slime' 'Seaside-GemStone-Flow' 'Seaside-GemStone-Continuation' 'Seaside-Tests-GemStone-Continuation').
			me values
				do:
					[ :pkg | 
					| grPkg |
					grPkg := gr at: pkg name ifAbsent: [  ].
					grPkg notNil
						ifTrue:
							[ | requires dependencies |
							requires := pkg requires.
							dependencies := grPkg dependencies.
							requires size ~= dependencies size
								ifTrue: [ self assert: (exceptions includes: pkg name) ]
								ifFalse:
									[ dependencies
										do:
											[ :grp | 
											(requires includes: grp name)
												ifFalse:
													[ (grease includes: pkg name)
														ifTrue: [ self assert: (grp name beginsWith: 'Grease') ]
														ifFalse: [ self assert: false ] ] ] ] ] ] ]! !

TestCase subclass: #WAPharoInspectorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Development'!

!WAPharoInspectorTest methodsFor: 'testing' stamp: 'jf 2/15/2010 01:06'!
testInspectorFields
	| values example fields association |
	self assert: Object new inspectorFields isEmpty.
	
	example := WAExampleClass new: 2.
	example first: 'Das Grosse Lernen'.
	example second: 'Die Analekten des Konfuzius'.
	example at: 1 put: 'Mitte und Mass'.
	example at: 2 put: 'Mengzi'.
	
	fields := example inspectorFields.
	self assert: fields size = 4.
	
	association := fields first.
	self assert: association key = #'first'.
	self assert: association value = 'Das Grosse Lernen'.
	
	association := fields second.
	self assert: association key = #'second'.
	self assert: association value = 'Die Analekten des Konfuzius'.
	
	association := fields third.
	self assert: association key = 1.
	self assert: association value = 'Mitte und Mass'.
	
	association := fields fourth.
	self assert: association key = 2.
	self assert: association value = 'Mengzi'.
	
	values := #('Das Grosse Lernen' 'Die Analekten des Konfuzius' 'Mitte und Mass' 'Mengzi').
	
	fields := values inspectorFields.
	self assert: fields size = 4.
	values keysAndValuesDo: [ :index :value |
		association := fields at: index.
		self assert: association key = index.
		self assert: association value = value ].
	
	example := Dictionary new.
	values keysAndValuesDo: [ :index :value |
		example at: index put: value ].
	
	fields := example inspectorFields.
	
	values keysAndValuesDo: [ :index :value |
		self assert: (fields at: index) value = value ]! !

GRObject variableSubclass: #WAExampleClass
	instanceVariableNames: 'first second'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Tests-Pharo-Development'!

!WAExampleClass methodsFor: 'accessing' stamp: 'pmm 3/24/2008 17:08'!
first
	^ first! !

!WAExampleClass methodsFor: 'accessing' stamp: 'pmm 3/24/2008 17:08'!
first: anObject
	first := anObject! !

!WAExampleClass methodsFor: 'accessing' stamp: 'pmm 3/24/2008 17:08'!
second
	^ second! !

!WAExampleClass methodsFor: 'accessing' stamp: 'pmm 3/24/2008 17:08'!
second: anObject
	second := anObject! !

!GRPackage class methodsFor: '*seaside-tests-pharo-development' stamp: 'jf 8/31/2009 14:31'!
seasideTestsPharoDevelopment
	^ self new
		name: 'Seaside-Tests-Pharo-Development';
		addDependency: 'Seaside-Pharo-Development';
		addDependency: 'Seaside-Tests-Development';
		yourself! !
